require "util"

local floor, sqrt, log10 = math.floor, math.sqrt, math.log10
local copy = util.table.deepcopy

local extender = 
    {
        {
            type='technology',
            name='infinite-research-red',
            icon="__infinite_research__/graphics/icons/infinite.png",
            effects = {},
            prerequisites={},
            unit = {
                count = 2000000000,
                ingredients = 
                {
                    {"science-pack-1", 1}
                },
                time = 30
            },
            order = "f-f-1"
        },
        {
            type='technology',
            name='infinite-research-green',
            icon="__infinite_research__/graphics/icons/infinite.png",
            effects = {},
            prerequisites={},
            unit = {
                count = 2000000000,
                ingredients = 
                {
                    {"science-pack-2", 1}
                },
                time = 30
            },
            order = "f-f-1"
        },
        {
            type='technology',
            name='infinite-research-blue',
            icon="__infinite_research__/graphics/icons/infinite.png",
            effects = {},
            prerequisites={},
            unit = {
                count = 2000000000,
                ingredients = 
                {
                    {"science-pack-3", 1}
                },
                time = 30
            },
            order = "f-f-1"
        },
        {
            type='technology',
            name='infinite-research-purple',
            icon="__infinite_research__/graphics/icons/infinite.png",
            effects = {},
            prerequisites={},
            unit = {
                count = 2000000000,
                ingredients = 
                {
                    {"alien-science-pack", 1}
                },
                time = 30
            },
            order = "f-f-1"
        },
        {
            type='technology',
            name='infinite-research-green-sum',
            icon="__infinite_research__/graphics/icons/infinite.png",
            effects = {},
            prerequisites={},
            unit = {
                count = 2000000000,
                ingredients = 
                {
                    {"science-pack-1", 1},
                    {"science-pack-2", 1}
                },
                time = 30
            },
            order = "f-f-1"
        },
        {
            type='technology',
            name='infinite-research-blue-sum',
            icon="__infinite_research__/graphics/icons/infinite.png",
            effects = {},
            prerequisites={},
            unit = {
                count = 2000000000,
                ingredients = 
                {
                    {"science-pack-1", 1},
                    {"science-pack-2", 1},
                    {"science-pack-3", 1}
                },
                time = 30
            },
            order = "f-f-1"
        },
        {
            type='technology',
            name='infinite-research-purple-sum',
            icon="__infinite_research__/graphics/icons/infinite.png",
            effects = {},
            prerequisites={},
            unit = {
                count = 2000000000,
                ingredients = 
                {
                    {"science-pack-1", 1},
                    {"science-pack-2", 1},
                    {"science-pack-3", 1},
                    {"alien-science-pack", 1}
                },
                time = 30
            },
            order = "f-f-1"
        },
        {
            type='technology',
            name='infinite-research-green-exp',
            icon="__infinite_research__/graphics/icons/infinite.png",
            effects = {},
            prerequisites={},
            unit = {
                count = 2000000000,
                ingredients = 
                {
                    {"science-pack-1", 2},
                    {"science-pack-2", 1}
                },
                time = 30
            },
            order = "f-f-1"
        },
        {
            type='technology',
            name='infinite-research-blue-exp',
            icon="__infinite_research__/graphics/icons/infinite.png",
            effects = {},
            prerequisites={},
            unit = {
                count = 2000000000,
                ingredients = 
                {
                    {"science-pack-1", 5},
                    {"science-pack-2", 2},
                    {"science-pack-3", 1}
                },
                time = 60
            },
            order = "f-f-1"
        },
        {
            type='technology',
            name='infinite-research-purple-exp',
            icon="__infinite_research__/graphics/icons/infinite.png",
            effects = {},
            prerequisites={},
            unit = {
                count = 2000000000,
                ingredients = 
                {
                    {"science-pack-1", 10},
                    {"science-pack-2", 5},
                    {"science-pack-3", 2},
                    {"alien-science-pack", 1}
                },
                time = 90
            },
            order = "f-f-1"
        },
    }

	
for _,t in pairs(extender) do
	t.unit.count = 100
end
	
function amp(techlist, tier)
	local mul, val, mag = 1.4^((tier+1)/2)
	for _,tech in pairs(extender) do
		entry = copy(tech)
		entry.name = tech.name.."-"..tier
		entry.upgrade = "true"
		
		val = entry.unit.count * mul
		mag = (10^floor(log10(val)))/4
		entry.unit.count = floor(val/mag)*mag
		
		if tier>2 then
			entry.prerequisites = {tech.name.."-"..(tier-1)}
		else
			entry.prerequisites = {tech.name}
		end
		
--		entry.unit.count = math.floor((entry.unit.count*math.sqrt(1.4^(tier-1)))/25) * 25
		data:extend{entry}
	end
end


data:extend(extender)

for i=2,99 do
	amp(extender,i)
end